
#ifndef _uidefs_h_ /* Sat Dec 25 09:21:26 1993 */
#define _uidefs_h_





/*
 *
 *          Copyright (C) 1994, M. A. Sridhar
 *  
 *
 *     This software is Copyright M. A. Sridhar, 1994. You are free
 *     to copy, modify or distribute this software  as you see fit,
 *     and to use  it  for  any  purpose, provided   this copyright
 *     notice and the following   disclaimer are included  with all
 *     copies.
 *
 *                        DISCLAIMER
 *
 *     The author makes no warranties, either expressed or implied,
 *     with respect  to  this  software, its  quality, performance,
 *     merchantability, or fitness for any particular purpose. This
 *     software is distributed  AS IS.  The  user of this  software
 *     assumes all risks  as to its quality  and performance. In no
 *     event shall the author be liable for any direct, indirect or
 *     consequential damages, even if the  author has been  advised
 *     as to the possibility of such damages.
 *
 */



#if !defined(__MS_WINDOWS__) && !defined(__X_MOTIF__)
#error uidefs.h: unsupported platform
#endif


#if defined (__X_MOTIF__)
extern "C" {
// These are stolen from X11/Intrinsic.h. They might have to be fixed up in
// future versions of X, if the definitions of "Widget" and "WidgetClass"
// change. We refrain from including Intrinsic.h here so as to minimize
// preprocessing time when compiling applications.
struct _WidgetRec;
struct _WidgetClassRec;
}
#endif


// Basic declarations for the user interface framework

// The View Id: a "persistent" way of identifying visual objects
typedef long UI_ViewID;

// The View Handle: a handle that varies between runs of the application.
// This typedef depends on platform.
#if defined(__MS_WINDOWS__)
#define NativeEventStruct MSG
typedef long UI_ViewHandle;
#elif defined(__X_MOTIF__)
#define NativeEventStruct XEvent
typedef struct _WidgetRec* UI_ViewHandle;
#endif


#if defined(__MS_WINDOWS__)
#elif defined (__X_MOTIF__)
#endif



#define YACL_WINDOW_CLASSNAME "YACLWindow"


enum UI_TextStyle {UIText_Left, UIText_Right, UIText_Center};

#ifdef __X_MOTIF__
# define FAR                      // Added 07/06/1994
#endif


#endif /* _uidefs_h_ */

